# param/ndt_localizer.param.yaml
---
localization:
  p2d_ndt_localizer_node:
    ros__parameters:
      ##### Define input and outputs:
      # Config of the input point cloud subscription
      observation_sub:
        history_depth: 10
      # Config of the maps point cloud subscription
      map_sub:
        history_depth: 1
      # Config of the maps point clouds to register
      pose_pub:
        history_depth: 10
      # Publish the result to `/tf` topic
      publish_tf: True
      # Maximum allowed difference between the initial guess and the ndt pose estimate
      predict_pose_threshold:
        # Translation threshold in meters
        translation: 50.0
        # Rotation threshold in radians
        rotation: 3.15
#      init_hack:
#        translation:
#          x: -14628.1
#          y: -84588.6
#          z: 42.758
#        quaternion:
#          x: 0.0
#          y: 0.0
#          z: 0.0
#          w: 1.0
      # localizer specific configuration
      localizer:
        #underlying voxel grid configuration of the map
        map:
          capacity: 1000000
          min_point:
            x: -20000.0
            y: -90000.0
            z: -339.0
          max_point:
            x: 10000.0
            y: 10000.0
            z: 261.0
          voxel_size:
            x: 3.5
            y: 3.5
            z: 3.5
        # ndt scan representation config
        scan:
          capacity: 55000
        # ndt optimization problem configuration
        optimization:
          outlier_ratio: 0.55 # default value from PCL
        # newton optimizer configuration
        optimizer:
          max_iterations: 30
          score_tolerance: 0.0002
          parameter_tolerance: 0.0002
          gradient_tolerance: 0.0002
          line_search:
            step_max: 0.12
            step_min: 0.0001
        # Maximum accepted duration between a scan and an initial pose guess
        guess_time_tolerance_ms: 1000000000000
